use warnings;
use strict;

use Test::More;
use Test::Exception;
use Test::MockModule;

use POWER::Email;

plan tests => 6;


my $Mail;
my $m = new Test::MockModule('POWER::Email');
$m->mock('_send_mail', sub { $Mail = shift; return });

my $tmpl;


$tmpl = <<'EO_TMPL';
To: root@localhost
Content-Type: TEXT/PLAIN;
    charset=US-ASCII

EO_TMPL
Email($tmpl, undef, {'no_such' => 'fake'});
like($Mail, qr{
    Content-Type:\s+MULTIPART/MIXED
    .*
    Content-Type:\s+TEXT/PLAIN;\s*charset=US-ASCII
    .*
    filename="no_such"
    }isx,                                       'folding in Content-Type');


$tmpl = <<'EO_TMPL';
To: root

EO_TMPL
Email($tmpl, undef, {"no\tsuch" => 'fake'});
like($Mail, qr{filename="no such"},             'attach filename with \t');
Email($tmpl, undef, {"no\nsuch" => 'fake'});
like($Mail, qr{filename="no such"},             'attach filename with \n');
Email($tmpl, undef, {"no\"such" => 'fake'});
like($Mail, qr{filename="no\\"such"},           'attach filename with "');
Email($tmpl, undef, {"no_such\\" => 'fake'});
like($Mail, qr{filename="no_such\\\\"},         'attach filename with \\');


$tmpl = <<'EO_TMPL';
To: root@localhost
Content-Type: TEXT/PLAIN; charset=US-ASCII




EO_TMPL
Email($tmpl);
is($Mail, $tmpl,                                '\n\n inside body');



